package com.yihu.quota.contants;

/**
 * @author l4qiang
 */
public interface JobConstant {
    /**
     * 任务状态
     */
    public enum Status {
        /**
         * 未执行
         */
        NotStart,

        /**
         * 正在执行
         */
        Running;

        public static Status fromInt(int x) {
            switch (x) {
                case 0:
                    return NotStart;
                case 1:
                    return Running;
                default:
                    return null;
            }
        }

        public static Status fromStr(String x) {
            switch (x) {
                case "0":
                    return NotStart;
                case "1":
                    return Running;
                default:
                    return null;
            }
        }
    }

    public enum ExecType {
        /**
         * 全量
         */
        Full,
        /**
         * 增量
         */
        Increment;

        public static ExecType fromInt(int x) {
            switch (x) {
                case 0:
                    return Full;
                case 1:
                    return Increment;
                default:
                    return null;
            }
        }

        public static ExecType fromStr(String x) {
            switch (x) {
                case "0":
                    return Full;
                case "1":
                    return Increment;
                default:
                    return null;
            }
        }
    }

    public enum ExecWay {
        /**
         * 手动执行
         */
        Manual,
        /**
         * Cron触发
         */
        Cron,

        /**
         * 事件触发
         */
        Trigger;

        public static ExecWay fromInt(int x) {
            switch (x) {
                case 0:
                    return Manual;
                case 1:
                    return Cron;
                case 2:
                    return Trigger;
                default:
                    return null;
            }
        }

        public static ExecWay fromStr(String x) {
            switch (x) {
                case "0":
                    return Manual;
                case "1":
                    return Cron;
                case "2":
                    return Trigger;
                default:
                    return null;
            }
        }

    }
}
