package com.yihu.quota.controller;

import com.yihu.ehr.constants.ApiVersion;
import com.yihu.ehr.constants.ServiceApi;
import com.yihu.ehr.controller.EnvelopRestEndPoint;
import com.yihu.ehr.util.rest.Envelop;
import com.yihu.quota.model.view.View;
import com.yihu.quota.model.view.ViewDimension;
import com.yihu.quota.service.view.ViewDimensionService;
import com.yihu.quota.service.view.ViewService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author janseny
 * @date 2018年9月26日
 */
@RestController
@RequestMapping(ApiVersion.Version1_0)
@Api(description = "OLAP 视图维度 控制入口")
public class ViewDimensionController extends EnvelopRestEndPoint {

    @Autowired
    private ViewDimensionService viewDimensionService;
    @Autowired
    private ViewService viewService;

    @ApiOperation(value = "添加视图维度")
    @RequestMapping(value = ServiceApi.StatisticView.ViewQuota.Add, method = RequestMethod.GET)
    public Envelop addViewDimension(
            @ApiParam(name = "code", value = "维度code", required = true)
            @RequestParam(value = "code", required = true) String code,
            @ApiParam(name = "name", value = "维度名称", required = true)
            @RequestParam(value = "name", required = true) String name,
            @ApiParam(name = "viewId", value = "多维数据集ID", required = true)
            @RequestParam(value = "viewId", required = true) String viewId,
            @ApiParam(name = "dimensionType", value = "维度类型，row：行维度，col：列维度，drill：钻取维度", required = false)
            @RequestParam(value = "dimensionType", required = false) String dimensionType,
            @ApiParam(name = "groupRow", value = "行维度组", required = false)
            @RequestParam(value = "groupRow", required = true) int groupRow,
            @ApiParam(name = "groupRowOrder", value = "组内行维度顺序", required = false)
            @RequestParam(value = "groupRowOrder", required = false) int groupRowOrder,
            @ApiParam(name = "columnDrillOrder", value = "列维度/钻取维度的顺序", required = false)
            @RequestParam(value = "columnDrillOrder", required = false) int columnDrillOrder,
            @ApiParam(name = "rowMemberOrderType", value = "行/列维度成员排序方式，name：按名称排序，sub_agg：按子聚合统计值排序", required = false)
            @RequestParam(value = "rowMemberOrderType", required = false) String memberOrderType,
            @ApiParam(name = "rowMemberCount", value = "行/列维度成员返回个数", required = false)
            @RequestParam(value = "rowMemberCount", required = false) int memberCount
    ){
        Envelop envelop = new Envelop();
        envelop.setSuccessFlg(true);
        try {
            View view = viewService.findOne(viewId);
            ViewDimension viewDimension = new ViewDimension();
            viewDimension.setViewId(viewId);
            viewDimension.setDimensionCode(code);
            viewDimension.setDimensionName(name);
            viewDimension.setEsIndex(view.getEsIndex());
            viewDimension.setEsIndex(view.getEsType());
            viewDimension.setDimensionType(dimensionType);
            viewDimension.setGroupRow(groupRow);
            viewDimension.setGroupRowOrder(groupRowOrder);
            viewDimension.setColumnDrillOrder(columnDrillOrder);
            viewDimension.setMemberOrderType(memberOrderType);
            viewDimension.setMemberCount(memberCount);
            viewDimensionService.save(viewDimension);
        }catch (Exception e){
            e.printStackTrace();
            envelop.setSuccessFlg(false);
        }
        return envelop;
    }

    @ApiOperation(value = "删除视图维度")
    @RequestMapping(value = ServiceApi.StatisticView.ViewQuota.Delete, method = RequestMethod.DELETE)
    public Envelop delViewDimension(
            @ApiParam(name = "id", value = "ID", required = true)
            @RequestParam(value = "id", required = true) int id){
        Envelop envelop = new Envelop();
        envelop.setSuccessFlg(true);
        viewDimensionService.delete(id);
        return envelop;
    }

}
