package com.yihu.quota.etl;

import com.yihu.quota.etl.convert.ConvertHelper;
import com.yihu.quota.model.dimension.TjQuotaDimensionSlave;
import com.yihu.quota.util.SpringUtil;
import com.yihu.quota.vo.FilterModel;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import java.util.List;

/**
 * Created by janseny on 2018/5/10.
 */
@Component
@Scope("prototype")
public class ExtractConverUtil {

    private Logger logger = LoggerFactory.getLogger(ExtractConverUtil.class);

    /**
     * 细维度数据转换
     *
     * @param filterModel
     * @param qds
     * @return
     */
    public FilterModel convert(FilterModel filterModel, List<TjQuotaDimensionSlave> qds) throws Exception {
        try {
            if (qds != null && qds.size() > 0 && filterModel.getDataList() != null && filterModel.getDataList().size() > 0) {
                for (TjQuotaDimensionSlave slave : qds) {
                    if (!StringUtils.isEmpty(slave.getConverClass())) {
                        return SpringUtil.getBean(ConvertHelper.class).convert(filterModel, slave);
                    }
                }
            } else {
                return filterModel;
            }
        } catch (Exception e) {
            throw new Exception("数据转换异常" + e.getMessage());
        }
        return null;
    }

}
