package com.yihu.quota.feign;


import com.yihu.ehr.constants.ApiVersion;
import com.yihu.quota.contants.MicroServiceApi;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import springfox.documentation.annotations.ApiIgnore;

/**
 * @author l4qiang
 */
@FeignClient(name = MicroServiceApi.Service.REDIS)
@RequestMapping(value = ApiVersion.Version1_0)
@ApiIgnore
public interface RedisClient {

    @ApiOperation("通过机构编码获取机构名称")
    @RequestMapping(value = MicroServiceApi.Redis.ORG_NAME, method = RequestMethod.GET)
    String getOrgName(
            @ApiParam(value = "key", required = true)
            @RequestParam(value = "key") String key);

    @ApiOperation("通过机构编码获取机构区域")
    @RequestMapping(value = MicroServiceApi.Redis.ORG_AREA, method = RequestMethod.GET)
    String getOrgArea(
            @ApiParam(value = "key", required = true)
            @RequestParam(value = "key") String key);
}
