package com.yihu.quota.feign;

import com.yihu.ehr.constants.ApiVersion;
import com.yihu.quota.contants.MicroServiceApi;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import springfox.documentation.annotations.ApiIgnore;

import java.io.Serializable;
import java.util.List;

/**
 * @author l4qiang
 */
@FeignClient(name = MicroServiceApi.Service.RESOURCE)
@RequestMapping(value = ApiVersion.Version1_0)
@ApiIgnore
public interface RsDictClient {
    @RequestMapping(value = MicroServiceApi.Resource.DICT_ENTRY, method = RequestMethod.GET)
    @ApiOperation(value = "根据code从缓存获取字典项值")
    String getCacheValue(
            @ApiParam(name = "dict") @RequestParam(value = "dict") String dict,
            @ApiParam(name = "code") @RequestParam(value = "code") String code);

    @RequestMapping(value = MicroServiceApi.Resource.DICT_ENTRIES, method = RequestMethod.GET)
    @ApiOperation(value = "根据dict从缓存获取字典项")
    List<Serializable> getCacheEntries(
            @ApiParam(name = "dict") @RequestParam(value = "dict") String dict);

    @RequestMapping(value = MicroServiceApi.Resource.DICT_ENTRY, method = RequestMethod.DELETE)
    @ApiOperation(value = "清空缓存字典项")
    void deleteCacheValue(
            @ApiParam(name = "dict") @RequestParam(value = "dict") String dict);
}
