package com.yihu.quota.model.dimension;

import org.hibernate.annotations.Formula;

import javax.persistence.*;

/**
 * 多维数据集维度的成员 entity
 * Created by wxw on 2018/9/7.
 * @author wxw
 */
@Entity
@Table(name = "olap_dimension_member")
public class DimensionMember {
    private Integer id;
    /**
     * 名称
     */
    private String name;
    /**
     * 编码
     */
    private String code;

    /**
     * 上级维度Id
     */
    private Integer dimensionId;
    /**
     * 维度层级
     */
    private Integer level;

    /**
     * 上级维度名称
     */
    private String dimensionName;

    /**
     * 数据类型
     */
    private String dataType;

    /**
     * 中间算法
     */
    private String algorithm;

    /**
     * 中间算法参数
     */
    private String parm;

    /**
     * 数据字典
     */
    private String dict;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", unique = true, nullable = false)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Column(name = "dimension_id")
    public Integer getDimensionId() {
        return dimensionId;
    }

    public void setDimensionId(Integer dimensionId) {
        this.dimensionId = dimensionId;
    }

    public Integer getLevel() {
        return level;
    }

    public void setLevel(Integer level) {
        this.level = level;
    }

    @Column(name = "data_type")
    public String getDataType() {
        return dataType;
    }

    public void setDataType(String dataType) {
        this.dataType = dataType;
    }

    public String getDict() {
        return dict;
    }

    public void setDict(String dict) {
        this.dict = dict;
    }



    public String getAlgorithm() {
        return algorithm;
    }

    public void setAlgorithm(String algorithm) {
        this.algorithm = algorithm;
    }

    public String getParm() {
        return parm;
    }

    public void setParm(String parm) {
        this.parm = parm;
    }

    @Formula("(SELECT odm.name FROM olap_dimension_member odm LEFT JOIN olap_dimension od ON od.id = odm.dimension_id WHERE odm.id  = id )")
    public String getDimensionName() {
        return dimensionName;
    }

    public void setDimensionName(String dimensionName) {
        this.dimensionName = dimensionName;
    }
}
