package com.yihu.quota.model.source;

import javax.persistence.*;
import java.util.List;

/**
 * Created by wxw on 2018/9/10.
 *
 * @author wxw.
 */
@Entity
@Table(name = "olap_data_sources_table")
public class DataSourcesTable {
    private Integer id;
    /**
     * 库: 1 hbase 2 mysql 3 elasticsearch
     */
    private Integer type;
    /**
     * 表名
     */
    private String tableName;

    /**
     * 表编码
     */
    private String tableCode;

    /**
     * 备注
     */
    private String note;
    /**
     * 主键字段名
     */
    private String primaryKeyName;

    /**
     * 临时字段，存放数据源表字段对应表信息
     */
    private List<DataSourcesTableField> dataSourcesTableFields;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", unique = true, nullable = false)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    @Column(name = "table_name")
    public String getTableName() {
        return tableName;
    }

    public void setTableName(String tableName) {
        this.tableName = tableName;
    }

    @Column(name = "table_code")
    public String getTableCode() {
        return tableCode;
    }

    public void setTableCode(String tableCode) {
        this.tableCode = tableCode;
    }

    public String getNote() {
        return note;
    }

    public void setNote(String note) {
        this.note = note;
    }

    @Column(name = "primary_key_name")
    public String getPrimaryKeyName() {
        return primaryKeyName;
    }

    public void setPrimaryKeyName(String primaryKeyName) {
        this.primaryKeyName = primaryKeyName;
    }

    @Transient
    public List<DataSourcesTableField> getDataSourcesTableFields() {
        return dataSourcesTableFields;
    }

    public void setDataSourcesTableFields(List<DataSourcesTableField> dataSourcesTableFields) {
        this.dataSourcesTableFields = dataSourcesTableFields;
    }
}
